Skip to main content

Self-hosted Retool stable release 3.334

Retool releases a version on the stable channel each quarter. A stable release is generally four versions behind the cloud-hosted version at the time.

Preparation and testing of a stable version occurs approximately four weeks prior to its release. Stable releases are rigorously tested before they are published. As the release cycle is less frequent, administrators can more easily maintain and upgrade deployments.

Retool supports each stable release for six months. During this time, Retool will release patch updates that contain bug fixes or security updates. Patch updates do not contain functionality changes and can be applied more quickly than performing a full version upgrade.

After six months, a stable release is considered deprecated. You can continue using a deprecated release but it will no longer receive updates. At this time, you should upgrade to the latest stable release.

Documentation for stable releases

Retool provides versioned product documentation for supported stable releases. When browsing Retool Docs, use the version dropdown menu in the navbar to switch to a relevant version.

Self-hosted Retool 3.334

Currently supported

ReleaseReleasedDigest
First3.334.0Mar 3, 2026sha256:6144a2cf9e7110f06d69a28959b9fb4a855cb93d4f30f2896ec07876360f4bb9
Latest3.334.25Jul 23, 2026sha256:e9e5ca66005fb03a9c1241b7441a11fc53e095fce345d7209ae0f1b9d278911a
Best practice
Subscribe to the Atom feed for 3.334 to get notified when new patch releases are available.

Major changes in this release

New features, significant changes, and any actions required when upgrading.

TypeChange
newAgents supports A2A protocol
A2A protocol support for triggering Retool agents from external agents is now available.
newAsk and Build mode with Assist
Users can toggle between exploration and building modes in Assist.
newAssist supports Azure OpenAI
Assist supports Azure OpenAI as a single model provider.
newAssist supports multipage
Assist now supports creating and editing multipage apps.
newAssist thread summarization
Assist automatically summarizes long threads.
deprecatedBaseten models updated
DeepSeek-V3.2 is now supported in Baseten, replacing the deprecated DeepSeek-R1.
newCreate README files for workflows
Create a README file in a workflow
newGoogle Gemini 3 Pro Preview available in Retool
Google Gemini 3 Pro Preview is now available in Retool.
newGoogle Slides integration
New integration with Google Slides
newHardened images available in stable channel
Optionally use security-hardened images for stable releases.
newImprovements to editing with Assist
Retool made improvements to the quality and speed of layout edits with Assist.
newImprovements to writing SQL with Assist
Retool made improvements to the quality of SQL queries written with Assist.
newLICENSE_KEY required for multiplayer on self-hosted in Q3 2026
LICENSE_KEY is required for multiplayer on self-hosted starting in Q3 2026.
newMulti-instance releases for Source Control
Multi-instance releases for Source Control are now generally available.
newMultiple Secrets Manager configurations beta
Self-hosted organizations can now create multiple Secrets Manger configurations and retrieve secrets from different locations.
newNew version of Microsoft SQL Server integration, planned deprecation of Version 1 and Version 2
A new version of the Microsoft SQL Server integration is available. Version 1 and Version 2 will be deprecated in the 2026 Q3 stable release.
newOpenAI GPT-5.1 available in Retool
OpenAI GPT-5.1 is now available in Retool.
newOpenAI GPT-5.2 available in Retool
Retool now supports GPT-5.2.
newResource type restrictions for self-hosted Retool
Self-hosted organizations can prevent users from creating or using certain types of resources.
newRole-based access controls for Assist
Assist now supports role-based access controls.
newTheming with Assist
Retool now supports additional controls for configuring your app theme with Assist.
newUnpublish a workflow release
Unpublish a release on protected and unprotected workflows.
22 changes

Patch release notes

Bug fixes, improvements, and other incremental updates across all patch releases in this release.

TypeDescription
3.334.251 change
security fixFixed a host header injection vulnerability in the Google SSO OAuth redirect flow. [#81541]
3.334.241 change
fixedFixed module UUID validation before Source Control page saves. [#80506]
3.334.231 change
security fixUpgraded qs and dompurify dependencies to address security vulnerabilities. Fixes GHSA-v8jm-5vwx-cfxm. [#80801]
3.334.211 change
fixedFixed group membership updates removing claimed or expired user invites. [#80449]
3.334.203 changes
fixedFixed app publishing failures in the new app builder caused by an incompatible gnutar version. [#80096]
security fixUpdated @anthropic-ai/sdk to patch insecure default file permissions in local filesystem memory tool. Fixes CVE-2026-41686. [#76713]
security fixFixed account enumeration in the password reset flow by not sending emails for nonexistent accounts. [#76498]
3.334.196 changes
fixedFixed protected workflow triggers not being reconciled on manifest-pinned releases, preventing cron and webhook triggers from firing after a source-control deploy. [#79039]
security fixHardened all backend git and zip write sinks against path traversal, closing a git-config injection RCE vector in external source-control sync. [#79372]
security fixFixed a symlink-traversal remote code execution vulnerability in classic source control commit sinks where a push of a crafted symlink could plant a payload in .git/hooks. [#79448]
security fixFixed a high severity security issue in Retool Forms. Blocked the $queryResponse system query from the public query endpoint, preventing anonymous callers from reading all prior form submissions. [#79546]
fixedFixed source control branch cleanup soft-deleting branches with uncommitted local work, which could cause those branch saves to appear as main-branch saves. [#79456]
fixedFixed a crash on the Commit and push button in the source control panel when the button was in a disabled state. [#79631]
3.334.185 changes
fixedUpdated OCI image Chainguard dependencies for PostgreSQL, ncurses, and file library. [#79219]
security fixPatched ws (CVE-2026-45736), brace-expansion (CVE-2026-45149), idna (CVE-2026-45409), and protobufjs (CVE-2026-45740) vulnerabilities. [#79185]
fixedFixed source control release manifest parsing to surface validation errors instead of silently dropping malformed manifests. [#78560]
fixedFixed public app shortlink lookups crossing space boundaries on self-hosted deployments with multiple spaces. [#77079]
fixedFixed branch cleanup job causing branch-only saves to appear on main by switching to soft deletion. [#78777]
3.334.171 change
changedReplaced Gemini 3 Pro Preview with Gemini 3.1 Pro Preview for Agents and AI queries. [#78209]
3.334.163 changes
fixedFixed agent tools not respecting folder-inherited grants when attaching workflows or agents as tools. [#77339]
fixedFixed Amazon Bedrock AI queries and Assist calls failing for customers in EU and APAC regions. [#77907]
fixedFixed query-level group permissions being incorrectly copied during multi-instance releases, which could grant access to the wrong groups. [#77916]
3.334.154 changes
security fixPatched DOMPurify to 3.4.0 to remediate FORBID_TAGS bypass and SAFE_FOR_TEMPLATES bypass. Fixes CVE-2026-41240, CVE-2026-41239, and CVE-2026-41238. [#77444]
security fixPatched multiple dependencies including basic-ftp, simple-git, fast-uri, fast-xml-parser, smol-toml, ws, hono, protobufjs, protobufjs-cli, react-devtools, markdown-it, postcss, and uuid. Fixes CVE-2026-41324, CVE-2026-44240, CVE-2026-6951, CVE-2026-6321, CVE-2026-6322, CVE-2026-44455, CVE-2026-44456, CVE-2026-44457, CVE-2026-44458, CVE-2026-44459, CVE-2024-37890, CVE-2026-44288, CVE-2026-44289, CVE-2026-44290, CVE-2026-44291, CVE-2026-44292, CVE-2026-44293, CVE-2026-44294, CVE-2026-44295, and CVE-2026-42290. [#77480]
fixedFixed agent imports failing for users with agent-scope access but no workflow-scope access. [#77337]
changedUpdated Chainguard OCI image dependencies. [#77434]
3.334.145 changes
fixedFixed empty config variables in retoolContext when changing environments. [#77153]
fixedFixed a workflow editor crash for non-editor users on protected workflows. [#77110]
fixedFixed the Agent Chat component displaying "Agent" instead of the agent name for users with use-only access. [#77098]
changedUpdated Chainguard OCI image dependencies. [#77199]
changedUpdated Chainguard OCI image dependencies. [#77308]
3.334.131 change
security fixFixed JDBC datasource connection pool sharing between different resources with the same URL. [#76934]
3.334.122 changes
fixedFixed workflows using npm libraries failing after pnpm 11.0.8 release. [#76814]
fixedFixed throttle and debounce options on event handlers not working as expected. [#76710]
3.334.112 changes
security fixPatched multiple npm and Python dependencies in backend, frontend, and Code Executor. Fixes CVE-2026-26996, CVE-2026-27903, CVE-2026-27904, GHSA-c7qv-q95q-8v27, GHSA-v8jm-5vwx-cfxm, CVE-2026-32141, CVE-2026-33937, CVE-2026-34043, CVE-2026-34601, CVE-2026-22815, CVE-2026-34515, CVE-2026-33349, CVE-2026-23745, and CVE-2026-23949. [#76417]
fixedFixed workflow source control deployment failures caused by createdBy metadata in protected trigger data. [#73990]
3.334.103 changes
security fixPatched 31 dependencies to address security vulnerabilities. Fixes CVE-2020-7661, CVE-2022-37601, CVE-2023-28155, CVE-2023-32681, CVE-2024-21536, CVE-2024-35195, CVE-2024-47081, CVE-2024-4128, CVE-2024-55565, CVE-2025-15284, CVE-2025-30359, CVE-2025-30360, CVE-2025-62718, CVE-2026-2391, CVE-2026-25645, CVE-2026-33036, CVE-2026-33532, CVE-2026-33671, CVE-2026-33750, CVE-2026-33891, CVE-2026-33894, CVE-2026-33895, CVE-2026-33937, CVE-2026-33938, CVE-2026-33939, CVE-2026-33940, CVE-2026-33941, CVE-2026-34043, CVE-2026-34601, CVE-2026-40175, CVE-2026-4800, CVE-2026-4867, CVE-2026-4923, and CVE-2026-4926. [#75988]
security fixUpgraded Node.js from 22.22.0 to 22.22.2. Fixes CVE-2026-21637, CVE-2026-21710, CVE-2026-21713, CVE-2026-21714, CVE-2026-21715, CVE-2026-21716, and CVE-2026-21717. [#75993]
fixedFixed Claude Haiku 4.5 model resolution by updating to versioned name claude-haiku-4-5-20251001. [#75906]
3.334.92 changes
security fixFixed DOM-based XSS vulnerability in legacy custom component iframe endpoints. [#75885]
security fixPatched multiple dependencies to address security vulnerabilities. Fixes CVE-2018-3728, CVE-2020-36604, CVE-2024-29041, CVE-2024-43796, CVE-2025-25288, CVE-2025-68157, CVE-2025-68458, CVE-2026-25639, CVE-2026-30951, CVE-2026-31938, CVE-2026-32141, GHSA-378v-28hj-76wf, GHSA-6475-r3vj-m8vf, GHSA-78xj-cgh5-2h22, and GHSA-m732-5p4w-x69g. [#75566]
3.334.85 changes
security fixUpdated protobufjs to 7.5.5, jsPDF to 4.0.0, DOMPurify to 3.4.0, and canvg to 3.0.11 in the Code Executor sandbox environment, and protobufjs in the gRPC connector. Fixes CVE-2026-41242 and CVE-2023-36665. [#75592]
improvedOptimized Snowflake connection validation to skip a redundant pre-check query, reducing unnecessary round-trips. [#75410]
changedUpdated curl to 8.19.0-r9 in the self-hosted container image. [#75459]
changedUpdated libpng to 1.6.58, libldap, libxml2, and ngtcp2 in the self-hosted container image. [#75386]
changedUpdated FreeTDS to 1.5.17, postgresql-16, ca-certificates, and other system packages in the self-hosted container image. [#75548]
3.334.74 changes
addedAdded SNOWFLAKE_VALIDATION_DISABLE_HEARTBEAT environment variable for Snowflake connection management on self-hosted deployments. [#75033]
fixedFixed Java version validation in self-hosted deployment checks to correctly detect Amazon Corretto. [#74557]
security fixPatched multiple security vulnerabilities in backend dependencies. Fixes CVE-2022-25883, CVE-2024-45296, CVE-2025-14874, CVE-2025-48924, CVE-2026-25535, CVE-2026-26960, CVE-2026-26996, CVE-2026-27601, CVE-2026-27699, CVE-2026-27903, CVE-2026-27904, CVE-2026-29786, GHSA-2g4f-4pwh-qvx6, GHSA-38c4-r59v-3vqw, GHSA-c7qv-q95q-8v27, GHSA-r275-fr43-pm7q, GHSA-r5mx-6wc6-7h9w, GHSA-v8jm-5vwx-cfxm, GHSA-w7fw-mjwx-w883, and GHSA-wf6x-7x77-mvgw. [#75160]
security fixPatched security vulnerabilities in ajv, markdown-it, path-to-regexp, and simple-git dependencies. Fixes CVE-2024-45296, GHSA-2g4f-4pwh-qvx6, GHSA-r275-fr43-pm7q, and GHSA-38c4-r59v-3vqw. [#75183]
3.334.51 change
fixedFixed an issue with Source Control where unprotecting an app or workflow without release artifacts can return a 404 error. [#74018]
3.334.41 change
fixedFixed synchronous workflow runs getting stuck in PENDING status when the workflow execution environment was unreachable. [#73598]
3.334.31 change
fixedFixed Snowflake OAuth infinite reauth loop caused by stale refresh token expiration not persisting after token refresh. [#72838]
3.334.17 changes
fixedFixed SAML SSO login failures for identity providers whose X.509 certificates contain large OID arc values. [#72515]
fixedFixed workflow block-level logs not appearing in run history when blocks were stopped mid-execution. [#72854]
fixedFixed workflow trigger environment mapping causing deployment failures when syncing workflows via Source Control. [#71491]
improvedImproved workflow block result storage configuration with WORKFLOW_BLOCK_STORAGE_LOCATION environment variable for switching between PostgreSQL and S3 storage. [#70932]
addedAdded support for the Workflows README beta setting. [#72724]
security fixPrevented XML files in Retool Storage from being rendered inline in browsers to mitigate XSLT transformation vulnerabilities. [#72814]
security fixChanged Retool Storage external URLs to download HTML and XHTML files as attachments instead of rendering inline in browsers. [#72454]
3.334.0197 changes
security fixFixed XSS vulnerability in REST API custom authentication by adding validation for custom auth URLs. [#70006]
fixedFixed AWS knowledge base vector queries failing with "AWS region is missing" error. [#70098]
fixedFixed an issue in Signature component when global orientation was not set as default. [#70074]
fixedFixed issue in Query Library where users were unable to add a new resource from the resource picker. [#70076]
fixedFixed navigation to shortlinked apps in presentation mode loading incorrect cached app. [#70221]
fixedFixed drag-and-drop issue with top folder drop zone. [#70227]
fixedFixed folder order when changing scope during drag operations. [#70213]
fixedFixed edit modal from resource dropdown appearing behind workflow canvas. [#70063]
fixedFixed transaction handling in workflow template conversion. [#69665]
fixedFixed Save button not appearing when adding or removing members from groups as admin or group admin. [#70145]
fixedImproved error message when attempting to rename protected apps. [#70147]
fixedFixed missing environment variable for Java database connector. [#70173]
addedAdded support for excludedAttributes=members query parameter in SCIM Get Group API to improve compatibility with SSO providers like Entra ID. [#69887]
addedAdded Assignment tab to group pages for RBAC management. [#70078]
changedChanged terminology from "private beta" to "closed beta" in API endpoints. [#70207]
improvedImproved Assist page switching behavior by disabling navigation while actively generating to prevent conflicts. [#70182]
improvedAdded visual indicator when page switching is disabled during Assist generation. [#70139]
improvedImproved folder ordering behavior in multiplayer editing. [#70140]
improvedEnabled plugin ordering synchronization in multiplayer. [#70242]
addedEnabled the Tavily resource type for all eligible customers. [#69721]
addedAdded support for YAML format OpenAPI specifications in OpenAPI resources. [#69826]
addedAdded ca-west-1 as a region option for AWS resources. [#69722]
addedAdded authorization code grant with PKCE as an OAuth 2.0 option for Snowflake resources. [#69586]
fixedFixed a bug that caused Secrets Manager secrets in resources not to work in public apps without a logged-in user. [#69873]
fixedFixed mobile video aspect ratio to be dynamic based on the source video dimensions. [#69740]
fixedFixed Scanner component to no longer add an extra leading zero when scanning UPC-A barcodes. [#69742]
fixedFixed an issue that prevented the camera from switching between front and back when using the WebView component in Retool Mobile. [#69770]
fixedFixed layout issue for HTML elements with data-click-target attribute. [#69821]
fixedFixed an issue where the module input window displays a JavaScript error under certain conditions. [#69777]
improvedImproved component tooltips to be hoverable so end users can follow Markdown links and copy text to their clipboard. [#69774]
fixedFixed an issue that caused an error when connecting to Snowflake via OAuth. Retool no longer sends the parameter prompt. This extension to the OAuth protocol is not supported by Snowflake, and was ignored in the past, but now Snowflake treats it as an error. [#69651]
fixedFixed custom groups being unarchived on plan upgrade. [#69625]
fixedFixed an issue where offline jobs would incorrectly parse request bodies as JSON when using non-JSON content types. [#69523]
improvedImproved resource Usage tab to display a trash badge for apps and workflows in trash folders. [#68220]
improvedImproved app transition feedback with loading indicator when using Go to app or utils.openApp. [#69767]
improvedImproved view mode performance by caching app data with service worker. [#69401]
improvedImproved code tree display consistency between single page and multipage apps. [#69763]
improvedImproved AWS Bedrock resource with updated AI21 Labs and Stability AI models. [#69518]
changedChanged Snowflake Node SDK to use version 2.2.0. [#69640]
security fixUpgraded jsPDF library to version 4.0.0 to address CVE-2025-68428. [#69875]
addedAdded an accessible focus state for Image components with a click handler. [#68740]
changedChanged behavior for Assist to show a loading spinner when Assist is about to execute an auto-submitted prompt. [#69313]
addedAdded a folder_id field to public API endpoints for GET /resources and GET /resources/:resourceId. [#69377]
addedAdded support for OpenAPI ParameterGroup editor for editing JSON objects in Guided REST mode. [#69395]
addedAdded support for returning a list of groups when requested from the GET /user_invites endpoint. [#69481]
improvedImproved custom component library editing in multiplayer mode for increased reliability. [#69515]
fixedFixed an issue where workflows libraries requirements.txt showed deleted library. [#69517]
fixedFixed an issue where the Re-auth button did not show for resource query tools in the agents tool creation canvas. [#69533]
fixedFixed an issue in workflows where function parameters were not evaluated for a duplicated function. [#69546]
removedRemoved the 'Require is not defined' lint warning in JavaScript code editor. [#69560]
removedRemoved OAuth access tokens and non-sensitive ID tokens from audit logs. [#69584]
fixedFixed an issue where granted permissions per resource for query authoring were not applied to auto-fixing queries. [#69592]
fixedFixed an issue with string interpolation in OpenAPI query blocks in workflows. [#69607]
fixedFixed an issue where long JavaScript query blocks in workflows caused a bug with scrolling. [#69613]
addedAdded an Assist section to the list of keyboard shortcuts, and added two new shortcuts: Switch to Ask mode and Switch to Build mode. [#69654]
fixedFixed an issue where Assist users saw an error when using Ask mode and generating apps from scratch with no resources configured in their organization. [#69745]
fixedFixed an issue with the UI in the event handler editor. [#69091]
addedAdded optional pagination to GET /accessTokens. [#69168]
addedAdded optional pagination to GET /user_requests. [#69183]
improvedImproved query handling logic for mobile apps to defer UI feedback until offline jobs actually run online. Added the Completed section back to the Offline Job Manager screen. [#69239]
fixedFixed an issue where users needed to be admins to have access to source control. Users just need manage access. [#69276]
addedAdded a new GET /deployments API endpoint to list source control deployments. Adds additional response body fields to the existing get deployment and trigger deployment endpoints. [#69283]
security fixChanged behavior so that the HTTP path field in the Databricks resource now sanitizes semicolons to prevent JDBC parameter injection. If you were previously including connection parameters in the HTTP path (e.g., /sql/1.0/warehouses/abc;parameter=value), these will now be stripped. Use the dedicated connection parameters field instead. [#69287]
addedAdded support for a Trigger authentication on every query option for GraphQL resources. [#69292]
addedAdded a list of groups the user is in to the GET /user API endpoint. [#69293]
addedAdded the ability for Assist to reference URL parameters when writing queries, transformers, and embedded expressions. [#69317]
fixedFixed an issue that could cause the OAuth callback URL to be incorrect when using Share credentials between users for a resource. [#69347]
addedFixed an issue in the SCIM API that prevented modification of default groups. [#69359]
fixedFixed an issue with Chart rendering when nested in Stacks. [#69374]
addedAdded support for additional permissions on business plans. [#69394]
fixedFixed autocomplete in resource fields to not show "secrets" as a global object if Secrets Manager is not enabled. [#68039]
addedAdded client credentials authentication for Databricks. [#68333]
fixedFixed an issue with merging branches in multiplayer. [#68428]
changedChanged Assist behavior so that when the default models are selected, Retool attempts to use the Anthropic resource for Anthropic requests, and sends requests to Anthropic through Amazon Bedrock as a fallback. [#68680]
changedChanged protected trigger feature to be generally available. [#68711]
improvedImproved GUI query behavior. [#68791]
fixedFixed an issue where containers on Android devices get a vertical empty space. [#68818]
fixedFixed an issue that allowed permission group creation on Free and Team plans. [#68890]
addedAdded search bar to Roles & Permissions page. [#68905]
improvedImproved PDF rotation in the PDF viewer component in Mobile to use native rotation support for smoother performance. Fixed an issue where very large PDFs in Mobile could cause memory issues. Improved page navigation in the PDF viewer component in Mobile to use native page navigation methods for more reliable page transitions. [#68909]
fixedFixed unsandboxed execution, which now reads max CPU/memory limits exclusively from env vars. [#68945]
addedAdded a new native video component for mobile apps. [#68957]
improvedImproved accessibility when setting up two-factor authentication. [#68992]
improvedImproved the way that Assist troubleshoots issues. [#68995]
removedRemoved resizability of the Description field of a role if the description itself cannot be edited. [#68999]
addedAdded new Secrets Manager scoped secrets behavior: if the SCOPED_SECRETS environment variable is true, then secrets whose names begin with scoped--resources--$FOLDER_NAME-- can only be used in resources within the specified folder. [#69045]
addedAdded support for pagination on the public API GET /groups method. [#69050]
addedAdded support for pagination on the public API GET /folders method. [#69052]
addedAdded support for pagination on the public API GET /spaces method. [#69054]
addedAdded support for pagination on the public API GET /apps method. [#69055]
improvedImproved UI of the OpenAPI resource editor. [#69062]
addedAdded bearer token authentication to MCP resources for use in Agents. [#69069]
addedAdded the ability to add and revoke screen access for groups with the API. [#69090]
addedAdded support for encoding user email in the Intercom JWT payload for improved authentication. [#69096]
fixedFixed baseDomain shown in source control deployment email alerts. [#69101]
fixedFixed a visual bug in column text colors. [#69103]
improvedImproved Assist's understanding of how to use the tools available to it. [#69107]
fixedFixed an issue so that when the SCOPED_SECRETS env var is enabled, autocompletion for template strings in resources will filter the secrets to omit any scoped secrets that are not available for that resource. [#69148]
fixedFixed an issue where reset password confirmation emails would still be sent to users even when reset password emails are disabled in an organization. [#69150]
fixedFixed an issue where Assist would incorrectly think it could not perform some tasks. [#69167]
addedAdded optional pagination to GET /user_invites for the public API. [#69170]
changedChanged behavior so that if the SCOPED_SECRETS env var is set, secrets with scoped names are shown separately in the Secrets Manager list. [#69177]
addedAdded optional pagination to GET /environments for the public API. [#69184]
addedAdded support for Assist to create forms outside of modals, when the form is the primary purpose of a page. [#69200]
removedRemoved sensitive user tokens from audit logs with OAuth2 SSO. [#69263]
fixedFixed an issue with HTML sanitization in the "Failed workflow" alert emails. [#66665]
fixedCustom component edits in apps will sync more consistently for multiple editors. [#68327]
addedAdds a shadow style property and basic organization-level theming support for Alert v2. [#68464]
changedRenamed the OpenAI resource to OpenAI Platform. [#68504]
addedAdded spell check support to editable string cells in Table and Key Value components. [#68571]
addedAdded support for GPT-5.1. [#68605]
addedAdded a shadow style property to the Image component. [#68619]
improvedExposed font names in the Theme object. [#68642]
improvedImproved the performance of Assist-generated UI changes to large apps. [#68657]
improvedImproved Assist's ability to write event handler scripts. [#68660]
addedAdded initialDeeplink object to the Retool mobile app model for accessing URL parameters and screen navigation information when an app is opened via a deep link. [#68661]
addedAdded the ariaLabel property to Link components. [#68678]
addedAdded availability for editing "Roles and permissions" to the Business plan. [#68686]
addedAdded a shadow style property to the ImageGrid component. [#68687]
fixedFixed an issue where queries containing the word "select" may return an error. [#68709]
addedAdded the gemini-3-pro-preview model for use in Retool AI. [#68716]
fixedFixed an issue with the State tab. [#68718]
addedAdded an additional permissions banner to the Groups page. [#68721]
addedAdded support for creating release artifacts of protected workflows from the configured default branch. [#68722]
addedAdded a search option to the Groups page. [#68732]
fixedFixed an issue with scrolling in the Roles page. [#68733]
fixedFixed an issue where Assist may remove existing column configuration properties that it doesn't support whenever it edits any table column. [#68752]
fixedFixed an issue where the navigation header may flash during redirect. [#68772]
fixedFixed an issue with multi-instance releases so users can protect an element, create a release artifact, and update the manifest in the same PR. [#68776]
improvedImproved accuracy of custom component library dev modes. [#68777]
fixedFixed an issue where an agent may attempt to continue, before a child agent, invoked as a tool, has finished. [#68790]
fixedFixed an issue where the Source Control branch menu may not load correctly. [#68852]
fixedFixed an issue where Code Executor does not support the LOG_LEVEL environment variable. [#68857]
improvedAdds pagination parameters to the getUsers Retool API endpoint. [#68859]
improvedImproved component icon handling for Assist. [#68862]
fixedFixed an issue that prevented the Retool API from creating folders without passing in parent_folder_id. [#68921]
improvedImproved the speed and quality of Assist edits on existing UI layouts. [#67848]
AddedAdded the excludeDisabledUsers query parameter to the Get group API endpoint that excludes disabled users from results. [#67939]
removedRemoved user access to app modules in other app pages if they only have access to a specific page, not the entire app. [#68088]
addedAdds a notification banner to Assist chat threads for token consumption awareness. [#68104]
addedAdded RESOURCE_TYPES_DENY_LIST_CREATE_ONLY env-var, which prevents users from creating new resources of specific types, but does not block queries the way RESOURCE_TYPES_DENY_LIST does. [#68260]
fixedFixes UI issue for thinking box states. [#68411]
RemovedUnprotected releases will no longer be protected upon app protection. [#68430]
FixedThe Access list modal for Apps now displays Groups with access. [#68436]
addedAdded the trigger type to workflowContext. [#68463]
addedAdded permission guards for resource access via Assist. [#68475]
improvedImproved the hint when there's existing messages in the thread in the Assist input text box. [#68481]
fixedFixed non-admin users ability to see the External Users group and any groups they are an admin of in Settings if they are group admins and have external Retool manage scope. [#68487]
fixedFixed an issue with Retool header flashing on redirect to a workspace. [#68490]
addedAdded sorting options to list of spaces in the Spaces settings. Defaults to alphabetical sorting based on space names. [#68495]
addedAdded support for Google Slides resources. [#68515]
fixedFixed an issue with REST API resources where the metadata.request properties may not always be correctly sanitized. [#68535]
fixedFixed an issue with OpenAPI resources where the metadata.request properties may not always be correctly sanitized. [#68540]
fixedFixed an issue with GraphQL resources where the metadata.request properties may not always be correctly sanitized. [#68552]
removedRemoved expiry warning banners during signup and guided-tour. [#68553]
addedAdded support for isEditorMode to QUERY_RUN audit trail log events. [#68591]
fixedFixed issues where Assist failed to add components to header frames. [#68604]
changedUpdated the app Share modal. [#66039]
fixedFix an incorrect documentation link for the Event List component. [#66131]
changedChanged the Login Retool Event to be enabled by default. [#66991]
addedAdded Google Slides tools to Retool Agents. [#65697]
improvedAssist can now verify the configuration of AI models and display an error if verification fails. [#67545]
fixedFixed an issue when opening an app in the IDE using the historyOffset URL parameter. [#67885]
addedAdded support for Azure OpenAI as a single model provider for Assist. [#68106]
security fixPatched a security issue related to auto-join domains. [#68143]
addedAdded support for Google Search grounding in Gemini for Retool AI. You can enable this option in the organizaton's Beta settings. [#68147]
fixedFixed an issue with placeholders in the Key Value component. [#68175]
improvedImproved the layout of the Workflows tab. [#68211]
improvedImproved visibility of errors when protected apps reference unprotected modules. [#68231]
addedAdded the RESOURCE_TYPES_DENY_LIST environment variable to prevent users from creating and running against the provided resource types. [#68251]
fixedFixed an issue where tooltips may not appear in the App IDE code editor. [#68254]
changedChanged references of AWS Bedrock to Amazon Bedrock. [#68256]
improvedImproved error reporting within single-model providers to show model-specific information. [#68273]
changedUser profile pictures now appear when viewing group members. [#68322]
fixedFixed an issue with renaming modules. [#68349]
fixedFixed an issue where global error handlers for workflows would trigger even when errors were already handled by block-level On Error handlers. [#70592]
improvedImproved workflow execution performance by using compressed block result sizes when determining whether to truncate large results exceeding 10MB. [#70698]
fixedFixed dropdown selection issues in the function canvas. [#70823]
fixedFixed token consumption calculation for Assist thread summarization and enabled it by default. [#70831]
fixedFixed a permission check that incorrectly restricted role-based access. [#70865]
fixedFixed UX when workflow block results are truncated due to size limits by showing run logs and hiding unusable filter button. [#70876]
fixedFixed an issue where AI queries were not emitting token usage telemetry. [#70966]
fixedFixed an issue where branch syncing incorrectly deleted release artifacts, manifests, and other non-branching files during merge commits. [#71067]
fixedFixed an issue where Azure Repos source control diffs included directory entries as files, which caused deployment errors during partial deploys. [#71155]
fixedFixed an issue where self-hosted instances were incorrectly logging to Retool's error tracking service. [#71193]
fixedFixed an issue with GitHub OAuth for MCP resources by including the required Accept: application/json header in access token requests. [#71194]
fixedFixed an issue where admins were unable to delete or move workflows when VERSION_CONTROL_LOCKED is enabled. [#71231]
fixedFixed Assist context window showing incorrect token counts when Anthropic prompt caching is active. [#71270]
fixedFixed source control manifest UI incorrectly passing file paths to Bitbucket API, which caused manifest contents to be wiped. [#71437]
security fixFixed authorization bypass vulnerability in folder deletion that allowed users without proper permissions to delete folders. [#71481]
fixedFixed an infinite retry loop in Assist single-shot agent mode. [#71499]
fixedFixed an issue where GitLab source control commits failed due to incorrect encoding of commit actions. [#71500]
changedChanged required permission level for folder delete, rename, and move to trash operations from edit to own access. [#71530]
fixedFixed template substitution not being applied to form data keys. [#72011]
fixedFixed Assist role-based access controls to correctly apply to the All Users group. [#72042]
fixedFixed an issue where queries using permissioned resources could not be disabled. [#72061]
fixedFixed missing telemetry for AI thread summarization. [#70767]
257 changes